# coding: utf-8

"""
    Slurm REST API

    API to access and control Slurm

    The version of the OpenAPI document: Slurm-24.05.5&openapi/dbv0.0.39&openapi/slurmctld&openapi/slurmdbd&openapi/v0.0.39
    Contact: sales@schedmd.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from slurmrestapi.models.dbv0039_error import Dbv0039Error
from slurmrestapi.models.dbv0039_meta import Dbv0039Meta
from slurmrestapi.models.dbv0039_warning import Dbv0039Warning
from slurmrestapi.models.v0039_account import V0039Account
from slurmrestapi.models.v0039_assoc import V0039Assoc
from slurmrestapi.models.v0039_cluster_rec import V0039ClusterRec
from slurmrestapi.models.v0039_qos import V0039Qos
from slurmrestapi.models.v0039_tres import V0039Tres
from slurmrestapi.models.v0039_user import V0039User
from slurmrestapi.models.v0039_wckey import V0039Wckey
from typing import Optional, Set
from typing_extensions import Self

class Dbv0039ConfigInfo(BaseModel):
    """
    Dbv0039ConfigInfo
    """ # noqa: E501
    meta: Optional[Dbv0039Meta] = None
    errors: Optional[List[Dbv0039Error]] = Field(default=None, description="Slurm errors")
    warnings: Optional[List[Dbv0039Warning]] = Field(default=None, description="Slurm warnings")
    tres: Optional[List[V0039Tres]] = None
    accounts: Optional[List[V0039Account]] = None
    associations: Optional[List[V0039Assoc]] = None
    users: Optional[List[V0039User]] = None
    qos: Optional[List[V0039Qos]] = None
    wckeys: Optional[List[V0039Wckey]] = None
    clusters: Optional[List[V0039ClusterRec]] = None
    __properties: ClassVar[List[str]] = ["meta", "errors", "warnings", "tres", "accounts", "associations", "users", "qos", "wckeys", "clusters"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Dbv0039ConfigInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of meta
        if self.meta:
            _dict['meta'] = self.meta.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in errors (list)
        _items = []
        if self.errors:
            for _item_errors in self.errors:
                if _item_errors:
                    _items.append(_item_errors.to_dict())
            _dict['errors'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in warnings (list)
        _items = []
        if self.warnings:
            for _item_warnings in self.warnings:
                if _item_warnings:
                    _items.append(_item_warnings.to_dict())
            _dict['warnings'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in tres (list)
        _items = []
        if self.tres:
            for _item_tres in self.tres:
                if _item_tres:
                    _items.append(_item_tres.to_dict())
            _dict['tres'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in accounts (list)
        _items = []
        if self.accounts:
            for _item_accounts in self.accounts:
                if _item_accounts:
                    _items.append(_item_accounts.to_dict())
            _dict['accounts'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in associations (list)
        _items = []
        if self.associations:
            for _item_associations in self.associations:
                if _item_associations:
                    _items.append(_item_associations.to_dict())
            _dict['associations'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in users (list)
        _items = []
        if self.users:
            for _item_users in self.users:
                if _item_users:
                    _items.append(_item_users.to_dict())
            _dict['users'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in qos (list)
        _items = []
        if self.qos:
            for _item_qos in self.qos:
                if _item_qos:
                    _items.append(_item_qos.to_dict())
            _dict['qos'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in wckeys (list)
        _items = []
        if self.wckeys:
            for _item_wckeys in self.wckeys:
                if _item_wckeys:
                    _items.append(_item_wckeys.to_dict())
            _dict['wckeys'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in clusters (list)
        _items = []
        if self.clusters:
            for _item_clusters in self.clusters:
                if _item_clusters:
                    _items.append(_item_clusters.to_dict())
            _dict['clusters'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Dbv0039ConfigInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "meta": Dbv0039Meta.from_dict(obj["meta"]) if obj.get("meta") is not None else None,
            "errors": [Dbv0039Error.from_dict(_item) for _item in obj["errors"]] if obj.get("errors") is not None else None,
            "warnings": [Dbv0039Warning.from_dict(_item) for _item in obj["warnings"]] if obj.get("warnings") is not None else None,
            "tres": [V0039Tres.from_dict(_item) for _item in obj["tres"]] if obj.get("tres") is not None else None,
            "accounts": [V0039Account.from_dict(_item) for _item in obj["accounts"]] if obj.get("accounts") is not None else None,
            "associations": [V0039Assoc.from_dict(_item) for _item in obj["associations"]] if obj.get("associations") is not None else None,
            "users": [V0039User.from_dict(_item) for _item in obj["users"]] if obj.get("users") is not None else None,
            "qos": [V0039Qos.from_dict(_item) for _item in obj["qos"]] if obj.get("qos") is not None else None,
            "wckeys": [V0039Wckey.from_dict(_item) for _item in obj["wckeys"]] if obj.get("wckeys") is not None else None,
            "clusters": [V0039ClusterRec.from_dict(_item) for _item in obj["clusters"]] if obj.get("clusters") is not None else None
        })
        return _obj


