# coding: utf-8

"""
    Slurm REST API

    API to access and control Slurm

    The version of the OpenAPI document: Slurm-24.05.5&openapi/dbv0.0.39&openapi/slurmctld&openapi/slurmdbd&openapi/v0.0.39
    Contact: sales@schedmd.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from slurmrestapi.models.v0041_openapi_slurmdbd_config_resp_qos_inner_preempt_exempt_time import V0041OpenapiSlurmdbdConfigRespQosInnerPreemptExemptTime
from typing import Optional, Set
from typing_extensions import Self

class V0041OpenapiSlurmdbdConfigRespQosInnerPreempt(BaseModel):
    """
    V0041OpenapiSlurmdbdConfigRespQosInnerPreempt
    """ # noqa: E501
    list: Optional[List[StrictStr]] = Field(default=None, description="Other QOS's this QOS can preempt")
    mode: Optional[List[StrictStr]] = Field(default=None, description="PreemptMode")
    exempt_time: Optional[V0041OpenapiSlurmdbdConfigRespQosInnerPreemptExemptTime] = None
    __properties: ClassVar[List[str]] = ["list", "mode", "exempt_time"]

    @field_validator('mode')
    def mode_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        for i in value:
            if i not in set(['DISABLED', 'SUSPEND', 'REQUEUE', 'CANCEL', 'GANG']):
                raise ValueError("each list item must be one of ('DISABLED', 'SUSPEND', 'REQUEUE', 'CANCEL', 'GANG')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of V0041OpenapiSlurmdbdConfigRespQosInnerPreempt from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of exempt_time
        if self.exempt_time:
            _dict['exempt_time'] = self.exempt_time.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of V0041OpenapiSlurmdbdConfigRespQosInnerPreempt from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "list": obj.get("list"),
            "mode": obj.get("mode"),
            "exempt_time": V0041OpenapiSlurmdbdConfigRespQosInnerPreemptExemptTime.from_dict(obj["exempt_time"]) if obj.get("exempt_time") is not None else None
        })
        return _obj


